/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "MonochromeLib.h"
#include "sprites.h"
#include "stdlib.h"
#include "stdio.h"
#include "syscall.h"
#include "fxlib.h"
#include "math.h"

#define __KEYBIOS_H__
#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48
#ifndef OS2Change
#define OS2Change
#ifndef OS2Change_GetOS2
#define OS2Change_GetOS2
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
int OSVersionAsInt(void)
{
    unsigned char mainversion;
    unsigned char minorversion;
    unsigned short release;
    unsigned short build;
    GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
    return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
#endif
#ifndef OS2Change_Keyboard
#define OS2Change_Keyboard
void delay(void)
{
    char i;
    for (i=0; i<5; i++){};
}
unsigned char CheckKeyRow(unsigned char code)
{
    unsigned char result=0;
    short*PORTB_CTRL=(void*)0xA4000102;
    short*PORTM_CTRL=(void*)0xA4000118;
    char*PORTB=(void*)0xA4000122;
    char*PORTM=(void*)0xA4000138;
    char*PORTA=(void*)0xA4000120;
    short smask;
    char cmask;
    unsigned char column, row;
    column = code>>4;
    row = code &0x0F;
    smask = 0x0003 << (( row %8)*2);
    cmask = ~( 1 << ( row %8) );
    if(row <8)
    {
        *PORTB_CTRL = 0xAAAA ^ smask;
        *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
        delay();
        *PORTB = cmask;
        *PORTM = (*PORTM & 0xF0 ) | 0x0F;
    }
    else
    {
        *PORTB_CTRL = 0xAAAA;
        *PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
        delay();
        *PORTB = 0xFF;
        *PORTM = (*PORTM & 0xF0 ) | cmask;
    }
    
    delay();
    result = (~(*PORTA))>>column & 1;
    delay();
    *PORTB_CTRL = 0xAAAA;
    *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
    delay();
    *PORTB_CTRL = 0x5555;
    *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
    delay();
    
    return result;
}

unsigned char KeyDown(unsigned char keycode)
{
    unsigned short key[8];
    const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
    if(isOS2)
    {
        unsigned char row = keycode%10;
        memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
        
        return (0 != (key[row >> 1] & 1 << keycode / 10 - 1 + ((row & 1) << 3)));
    }
    else
    {
        return CheckKeyRow((keycode % 10) + ((keycode / 10 - 1) << 4));
    }
}
unsigned char GetKeyMod(unsigned int *key)
{
    unsigned char x, ret;
    
    ret = GetKey(key);
    
    for(x = 0; x < 80; x++)
    {
        if(KeyDown(x))
        {
            *key = x;
            break;
        }
    }
    return ret;
}
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)
#define GetKey(x) GetKeyMod(x)
#endif
#endif


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int contagion=1, letalite=0, severite=1, mutation=0, recherche=0, priorite=0, limite=100, sain=60000, infect=0, gueri=0, mort=0, sain_av=0, infect_av=0, gueri_av=0, mort_av=0, transmission=0, symptome=0, capacite=0, fd=0, ptADN=0, i=0, j=0, a=0, sprite_avion[4]={0,0,0,0}, map=0, x=0, y=0, fin=0;
int xAeroport_depart[4]={0,0,0,0}, yAeroport_depart[4]={0,0,0,0}, xCoord_avion[4]={0,0,0,0}, yCoord_avion[4]={0,0,0,0}, xAeroport_arrive[4]={0,0,0,0}, yAeroport_arrive[4]={0,0,0,0}, Save[50], avion=0;
int transTableau[4][8]={{1,3,3,0,3,0,0,0},{0,0,0,3,0,0,0,0},{0,3,0,0,0,0,0,3},{0,0,0,0,3,0,0,3}}, capaTableau [4][8]={{1,0,0,0,0,0,0,0},{3,3,0,3,0,0,0,0},{0,0,0,0,3,0,0,0},{0,0,0,0,0,0,0,0}};
double changement=0.01, variable=0;
unsigned char str [20];
unsigned int hours, mins, secs, msecs, timeActu[4]={0,0,0,0}, timeRef[4]={0,0,0,0}, key=0;
const unsigned char *avionsSens[4]={avionN, avionE, avionS, avionO};
const unsigned char *piece[3]={piece_sel, piece_cacheSel, piece_cache};
const unsigned char *monde[2]={monde_sans, monde_avec};
const unsigned char *trans[13]={trans_Air1, trans_Air2, trans_Air3, trans_AirEau, trans_Bird1, trans_Bird2, trans_Blood1, trans_Blood2, trans_Blood3, trans_Eau1, trans_Eau2, trans_Rat1, trans_Rat2};
const unsigned char *capa[6]={capa_cold, capa_hot, capa_gen, capa_genHard, capa_envi, capa_medic};
FONTCHARACTER timeSave[]={'\\','\\','f','l','s','0','\\','p','l','a','g','u','e','.','t','m','p',0};
FONTCHARACTER save[]={'\\','\\','f','l','s','0','\\','p','l','a','g','u','e','.','s','a','v',0};
int AddIn_main()
{
    fd=Bfile_OpenFile(save, _OPENMODE_READ);
    if (fd==0) {
        Bfile_CreateFile(save, 100);
        Bfile_CreateFile(timeSave, 16);
    }
    else {
        fd=Bfile_OpenFile(save,_OPENMODE_READ);
        Bfile_ReadFile(fd,Save,100,-1);
        Bfile_CloseFile(fd);
        
        fd=Bfile_OpenFile(timeSave,_OPENMODE_READ);
        Bfile_ReadFile(fd,timeRef,16,-1);
        Bfile_CloseFile(fd);
    }
    ML_clear_vram();
    ML_bmp_or(titre,0,0,128,64);
    ML_display_vram();
    GetKey(&key);
    RTC_GetTime(&hours, &mins, &secs, &msecs);
    timeRef[0]=hours;
    timeRef[1]=mins;
    timeRef[2]=secs;
    timeRef[3]=msecs;
    ML_clear_vram();
    ML_bmp_or(monde[map],0,0,128,64);
    ML_display_vram();
    while (fin==0){
        timeActu[0]=timeRef[0];
        timeActu[1]=timeRef[1];
        timeActu[2]=timeRef[2];
        timeActu[3]=timeRef[3];
    while ((timeActu[1]-timeRef[1]<1) && fin==0){
        //gestion touches en IsKeyDown a faire ici
        // ci-dessous gestion des avions
        if (IsKeyDown(KEY_CTRL_SHIFT))menuMaladie();
        if (IsKeyDown(KEY_CTRL_EXIT))fin=1;
        if (IsKeyDown(KEY_CTRL_OPTN)){
            map = (map+1) % 2;
            if (map==1){
                ML_clear_vram();
                ML_bmp_or(monde[map],0,0,128,64);
                sprintf(str,"%d",ptADN);
                PrintMini(10,58,str,0);
                ML_display_vram();
                key=0;
                while (key != KEY_CTRL_F6)
                {
                    GetKey(&key);
                }
                map=0;
                key=0;
            }
            ML_clear_vram();
            ML_bmp_or(monde[map],0,0,128,64);
            ML_display_vram();
        }
        Sleep(100);
        if (map==0){
        for (i=0; i<4; i++){
            avion = xAeroport_depart[i];
            if (avion==0){
                avion=rand() % (9-1)+1;
                if (avion==1)a = (rand() % (4-1)+1);
                if (avion==2 || avion==3 || avion==5 || avion==6 || avion==8)a = (rand() % (3-1)+1);
                switch (a){
                    case 1:
                        if (avion==1)a=2;
                        if (avion==2)a=3;
                        if (avion==3)a=4;
                        if (avion==5)a=6;
                        if (avion==6)a=8;
                        if (avion==8)a=1;
                        break;
                    case 2:
                        if (avion==1)a=5;
                        if (avion==2)a=1;
                        if (avion==3)a=2;
                        if (avion==5)a=1;
                        if (avion==6)a=5;
                        if (avion==8)a=6;
                        break;
                    case 3:
                        if (avion==1)a=8;
                        break;
                };
                switch (avion){
                    case 1:
                        xAeroport_depart[i]=65;
                        yAeroport_depart[i]=18;
                        if (a==2){
                            xAeroport_arrive[i]=80;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=1;
                        }
                        if (a==5){
                            xAeroport_arrive[i]=65;
                            yAeroport_arrive[i]=41;
                            sprite_avion[i]=2;
                        }
                        if (a==8){
                            xAeroport_arrive[i]=32;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=3;
                        }
                        break;
                    case 2:
                        xAeroport_depart[i]=80;
                        yAeroport_depart[i]=18;
                        if (a==3){
                            xAeroport_arrive[i]=102;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=1;
                        }
                        if (a==1){
                            xAeroport_arrive[i]=65;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=3;
                        }
                        break;
                    case 3:
                        xAeroport_depart[i]=102;
                        yAeroport_depart[i]=18;
                        if (a==4){
                            xAeroport_arrive[i]=102;
                            yAeroport_arrive[i]=48;
                            sprite_avion[i]=2;
                        }
                        if (a==2){
                            xAeroport_arrive[i]=80;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=3;
                        }
                        break;
                    case 4:
                        xAeroport_depart[i]=102;
                        yAeroport_depart[i]=48;
                        xAeroport_arrive[i]=102;
                        yAeroport_arrive[i]=18;
                        sprite_avion[i]=0;
                        break;
                    case 5:
                        xAeroport_depart[i]=65;
                        yAeroport_depart[i]=42;
                        if (a==6){
                            xAeroport_arrive[i]=32;
                            yAeroport_arrive[i]=42;
                            sprite_avion[i]=3;
                        }
                        if (a==1){
                            xAeroport_arrive[i]=65;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=0;
                        }
                        break;
                    case 6:
                        xAeroport_depart[i]=32;
                        yAeroport_depart[i]=42;
                        if (a==8){
                            xAeroport_arrive[i]=32;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=0;
                        }
                        if (a==5){
                            xAeroport_arrive[i]=65;
                            yAeroport_arrive[i]=42;
                            sprite_avion[i]=1;
                        }
                        break;
                    case 7:
                        xAeroport_depart[i]=24;
                        yAeroport_depart[i]=18;
                        xAeroport_arrive[i]=32;
                        yAeroport_arrive[i]=18;
                        sprite_avion[i]=1;
                        break;
                    case 8:
                        xAeroport_depart[i]=32;
                        yAeroport_depart[i]=18;
                        if (a==1){
                            xAeroport_arrive[i]=65;
                            yAeroport_arrive[i]=18;
                            sprite_avion[i]=1;
                        }
                        if (a==6){
                            xAeroport_arrive[i]=32;
                            yAeroport_arrive[i]=42;
                            sprite_avion[i]=2;
                        }
                        break;
                }
                xCoord_avion[i] = xAeroport_depart[i];
                yCoord_avion[i] = yAeroport_depart[i];
            }
            else {
                if (((xCoord_avion[i] != xAeroport_arrive[i]) || (yCoord_avion[i] != yAeroport_arrive[i])) && map==0){
                    
                    switch (sprite_avion[i]){
                        case 0:
                            yCoord_avion[i]--;
                            break;
                        case 1:
                            xCoord_avion[i]++;
                            break;
                        case 2:
                            yCoord_avion[i]++;
                            break;
                        case 3:
                            xCoord_avion[i]--;
                            break;
                    }
                }
                else{
                    xCoord_avion[i]=0;
                    yCoord_avion[i]=0;
                    
                    xAeroport_arrive[i]=0;
                    yAeroport_depart[i]=0;
                    
                    xAeroport_depart[i]=0;
                    yAeroport_arrive[i]=0;
                    
                    sprite_avion[i]=0;
                }
            }
        }//fin du for des avions
        ML_clear_vram();
        ML_bmp_or(monde[map],0,0,128,64);
        for (j=0; j<4; j++){
            x = xCoord_avion[j];
            y = yCoord_avion[j];
            if (xCoord_avion[j] != 0)ML_bmp_xor(avionsSens[sprite_avion[j]],x,y,6,6);
        }
        ML_display_vram();
        }
        RTC_GetTime(&hours, &mins, &secs, &msecs);
        timeActu[0]=hours;
        timeActu[1]=mins;
        timeActu[2]=secs;
        timeActu[3]=msecs;
    }
       //fin de la journée
    }
    return 1;
}
menuMaladie()
{
    while (key != KEY_CTRL_F6 && key != KEY_CTRL_F5){
        ML_clear_vram();
        ML_bmp_or(menu,0,0,128,64);
        ML_bmp_or(trans[transmission],65,15,15,15);
        ML_bmp_or(capa[capacite],35,15,15,15);
        sprintf(str,"%d",ptADN);
        PrintMini(10,58,str,0);
        variable = (50*contagion)/11;
        a = floor(variable+28);
        ML_horizontal_line(49,28,a,1);
        ML_horizontal_line(48,28,a,1);
    
        variable = (50*letalite)/25;
        a = floor(variable+28);
        ML_horizontal_line(54,28,a,1);
        ML_horizontal_line(55,28,a,1);
    
        variable = (50*severite)/20;
        a = floor(variable+28);
        ML_horizontal_line(60,28,a,1);
        ML_horizontal_line(61,28,a,1);
        ML_display_vram();
        key=0;
        a=0;
        GetKey(&key);
        switch (key)
        {
            case KEY_CTRL_F1:
                break;
            case KEY_CTRL_F2:
                a=2;
                break;
            case KEY_CTRL_F3:
                a=3;
                break;
        }
        while (a==2){
            ML_clear_vram();
            ML_bmp_or(capaTable,0,0,128,64);
            for (y=0; y<4; y++){
                for (x=0; x<8; x++){
                    if (capaTableau[y][x] != 0)ML_bmp_or_cl(piece[capaTableau[y][x]-1],16*x-1,16*y-1,17,17);
                }
            }
            ML_display_vram();
            GetKey(&key);
            switch (key)
            {
                case KEY_CTRL_UP:
                    verif();
                    if (y > 0)
                    {
                        if (capaTableau[y-1][x]==0)capaTableau[y-1][x]=1;
                        else capaTableau[y-1][x]=2;
                        quitPiece();
                    }
                    break;
                case KEY_CTRL_RIGHT:
                    verif();
                    if (x < 7)
                    {
                        if (capaTableau[y][x+1]==0)capaTableau[y][x+1]=1;
                        else capaTableau[y][x+1]=2;
                        quitPiece();
                    }
                    break;
                case KEY_CTRL_DOWN:
                    verif();
                    if (y < 3)
                    {
                        if (capaTableau[y+1][x]==0)capaTableau[y+1][x]=1;
                        else capaTableau[y+1][x]=2;
                        quitPiece();
                    }
                    break;
                case KEY_CTRL_LEFT:
                    verif();
                    if (x > 0)
                    {
                        if (capaTableau[y][x-1]==0)capaTableau[y][x-1]=1;
                        else capaTableau[y][x-1]=2;
                        quitPiece();
                    }
                    break;
                case KEY_CTRL_SHIFT:
                    a=0;
                    break;
            }
        }
        while (a==3)
        {
            ML_clear_vram();
            ML_bmp_or(transTable,0,0,128,64);
            for (y=0; y<4; y++){
                for (x=0; x<8; x++){
                    if (transTableau[y][x] != 0)ML_bmp_or_cl(piece[transTableau[y][x]-1],16*x-1,16*y-1,17,17);
                }
            }
            ML_display_vram();
            GetKey(&key);
            switch (key)
            {
                case KEY_CTRL_UP:
                    verif();
                    if (y > 0)
                    {
                        if (transTableau[y-1][x]==0)transTableau[y-1][x]=1;
                        else transTableau[y-1][x]=2;
                    quitPiece();
                    }
                    break;
                case KEY_CTRL_RIGHT:
                    verif();
                    if (x < 7)
                    {
                        if (transTableau[y][x+1]==0)transTableau[y][x+1]=1;
                        else transTableau[y][x+1]=2;
                    quitPiece();
                    }
                    break;
                case KEY_CTRL_DOWN:
                    verif();
                    if (y < 3)
                    {
                        if (transTableau[y+1][x]==0)transTableau[y+1][x]=1;
                        else transTableau[y+1][x]=2;
                    quitPiece();
                    }
                    break;
                case KEY_CTRL_LEFT:
                    verif();
                    if (x > 0)
                    {
                        if (transTableau[y][x-1]==0)transTableau[y][x-1]=1;
                        else transTableau[y][x-1]=2;
                    quitPiece();
                    }
                    break;
                case KEY_CTRL_SHIFT:
                    a=0;
                    break;
            }
        }
    }
    key=0;
    map=0;
}
int verif()
{
    for (y=0; y<4; y++){
        for (x=0; x<8; x++){
            if (a==2){
                if (capaTableau[y][x] == 1 || capaTableau[y][x] == 2)return 1;
            }
            if (a==3){
                if (transTableau[y][x] == 1 || transTableau[y][x] == 2)return 1;
            }
        }
    }
    return 0;
}
quitPiece()
{
    if (a==2){
        if (capaTableau[y][x] == 1)capaTableau[y][x] = 0;
        else capaTableau[y][x] = 3;
    }
    if (a==3){
        if (transTableau[y][x] == 1)transTableau[y][x] = 0;
        else transTableau[y][x] = 3;
    }
}

//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

